/*
* Copyright (c) 2007, Dustin Spicuzza <dustin@virtualroadside.com>
* All rights reserved.
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of Dustin Spicuzza nor the
*       names of any contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY DUSTIN SPICUZZA AND CONTRIBUTORS ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*	phpExec - a program that forks off and executes a script. Really, this can
*	be used for a lot more purposes than just phpExec... this is a very simple 
*	program.
*
*/

#include <sys/types.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <stdio.h>

int main(int argc, char *argv[]) {

	pid_t child;

	// ignore children :o 
	signal(SIGCLD, SIG_IGN);
	
	child = fork();
			
	switch (child){
		case -1:
			// some error, oops..
			exit(1);
				
		case 0:
			// child process 
			fclose(stdout);
			fclose(stdin);
			fclose(stderr);

			// execute the shell, wait for it -- this could be done in a lot of
			// different ways, but this is a working proof of concept
			system("./phpexec.sh");

			exit(0);
			break;
					
		default:
			// don't need to do anything here
			break;
	}
	

	printf("phpExec child was executed!\n");
	exit(0);
}


